unit uLibipriv;

interface

//  
const
  CRYPT_ERR_BAD_ARGS = -1; //   
  CRYPT_ERR_OUT_OF_MEMORY = -2; //   
  CRYPT_ERR_INVALIDFORMAT = -3; //   
  CRYPT_ERR_NO_DATA_FOUND = -4; //     
  CRYPT_ERR_INVALID_PACKET_FORMAT = -5;
  //     
  CRYPT_ERR_UNKNOWN_ALG = -6; //   
  CRYPT_ERR_INVALID_KEYLEN = -7; //      
  CRYPT_ERR_INVALID_PASSWD = -8; //     
  CRYPT_ERR_DOCTYPE = -9; //   
  CRYPT_ERR_RADIX_DECODE = -10; //  ASCII  
  CRYPT_ERR_RADIX_ENCODE = -11; //  ASCII  
  CRYPT_ERR_INVALID_ENG = -12; //   
  CRYPT_ERR_ENG_NOT_READY = -13; //   
  CRYPT_ERR_NOT_SUPPORT = -14; //    
  CRYPT_ERR_FILE_NOT_FOUND = -15; //   
  CRYPT_ERR_CANT_READ_FILE = -16; //   
  CRYPT_ERR_INVALID_KEY = -17; //     
  CRYPT_ERR_SEC_ENC = -18; //   
  CRYPT_ERR_PUB_KEY_NOT_FOUND = -19;
  //       
  CRYPT_ERR_VERIFY = -20; //     
  CRYPT_ERR_CREATE_FILE = -21; //   
  CRYPT_ERR_CANT_WRITE_FILE = -22; //    
  CRYPT_ERR_INVALID_KEYCARD = -23; //    
  CRYPT_ERR_GENKEY = -24; //   
  CRYPT_ERR_PUB_ENC = -25; //  
  CRYPT_ERR_SEC_DEC = -26; //  

  //  
  IPRIV_ENGINE_RSAREF = 0; //  RSAREF
  IPRIV_ENGINE_OPENSSL = 1; //  OpenSSL
  IPRIV_ENGINE_PKCS11 = 2; //  PKCS11 (  eToken)
  IPRIV_ENGINE_WINCRYPT = 3; //  Microsoft Windows CryptoAPI

  IPRIV_ENGINE_DEFAULT = IPRIV_ENGINE_RSAREF;
  IPRIV_DEFAULT_ENGINE = IPRIV_ENGINE_DEFAULT;

  //    
  IPRIV_MAX_ENG_NUM = 4;

  //     (   Crypt_Ctrl)
  IPRIV_ENGCMD_IS_READY = 0; // in: none, retval: 1-ready, 0 - not ready
  IPRIV_ENGCMD_GET_ERROR = 1; // in: none, retval: errcode
  IPRIV_ENGCMD_SET_PIN = 2;
  // in: const char* null-terminated pin code, retval: 0-success
  IPRIV_ENGCMD_SET_PKCS11_LIB = 3;
  // in: static const char* null-terminated path to library, retval: 0-success
  IPRIV_ENGCMD_GET_PKCS11_SLOTS_NUM = 4; // in: none, retval - slots num or 0
  IPRIV_ENGCMD_GET_PKCS11_SLOT_NAME = 5;
  // in: int slot index, char* dst, int ndst, retval - string length
  IPRIV_ENGCMD_SET_PKCS11_SLOT = 6;
  // in: int slot index (from 0), retval - 0-success
  IPRIV_ENGCMD_ENUM_PKCS11_KEYS = 7;
  // in: IPRIV_KEY* array, int array max size, retval - keys num
  IPRIV_ENGCMD_ENUM_PKCS11_PUBKEYS = 8;
  // in: IPRIV_KEY* array, int array max size, retval - keys num

  //  
  IPRIV_KEY_TYPE_RSA_SECRET = 1;
  IPRIV_KEY_TYPE_RSA_PUBLIC = 2;

  //    
  MAX_USERID_LENGTH = 20;

type
  //  
  IPRIV_KEY = record
    eng: smallint; //  
    types: smallint; //  
    keyserial: longword; //   
    userid: array [1 .. 24] of AnsiChar; //  
    key: pointer; //    
  end;

  PIPRIV_KEY = ^IPRIV_KEY;

type
  //  .
  //         (  ).
  // : 0 -    
  TCrypt_Initialize = function: Integer; stdcall;

  //    .
  //       .
  // ,  -      eToken.
  // eng: ,  
  // cmd: ,  
  // :    
  TCrypt_Ctrl_Null = function(eng: Integer; cmd: Integer): Integer; stdcall;
  TCrypt_Ctrl_String = function(eng: Integer; cmd: Integer;
    const arg: PAnsiChar): Integer; stdcall;
  TCrypt_Ctrl_Int = function(eng: Integer; cmd: Integer; arg: Integer)
    : Integer; stdcall;
  TCrypt_Ctrl_Ptr = function(eng: Integer; cmd: Integer; arg: pointer)
    : Integer; stdcall;
  //      (Crypt_GenKeyCard)    (Crypt_GenKeyCardToFile).
  // dst: ,      
  // ndst: ,    
  // path: ,      
  // userid: ,  
  // keyserial: ,   
  // :      

  TCrypt_GenKeyCard = function(dst: PAnsiChar; ndst: Integer;
    const userid: PAnsiChar; keyserial: longword): Integer; stdcall;
  TCrypt_GenKeyCardToFile = function(const path: PAnsiChar;
    const userid: PAnsiChar; keyserial: longword): Integer; stdcall;

  //   
  // path: ,      
  // keyserial: ,   
  // userid: ,  
  // : 0 -    

  TCrypt_ReadKeyCardFromFile = function(const path: PAnsiChar;
    keyserial: longword; userid: PAnsiChar): Integer; stdcall;

  //     = function(/)    .
  // eng: ,  
  // src: ,     
  // nsrc: ,  , -1 -    = function(  -)
  // keycardpath: ,      
  // sec: ,  
  // pub: ,  
  // bits: ,    
  // : 0 -    

  TCrypt_GenKey = function(eng: Integer; const src: PAnsiChar; nsrc: Integer;
    sec: PIPRIV_KEY; pub: PIPRIV_KEY; bits: Integer): Integer; stdcall;
  TCrypt_GenKeyFromFile = function(eng: Integer; const keycardpath: PAnsiChar;
    sec: PIPRIV_KEY; pub: PIPRIV_KEY; bits: Integer): Integer; stdcall;
  TCrypt_GenKey2 = function(eng: Integer; keyserial: longword;
    const userid: PAnsiChar; sec: PIPRIV_KEY; pub: PIPRIV_KEY; bits: Integer)
    : Integer; stdcall;

  //         = function(Crypt_OpenSecretKey),    = function(Crypt_OpenSecretKeyFromFile)
  //       = function(Crypt_OpenSecretKeyFromStore).
  // eng: ,  
  // src: ,     
  // nsrc: ,  , -1 -    = function(  -)
  // path: ,      
  // passwd: ,      
  // keyserial: ,    
  // key: ,  
  // : 0 -    

  TCrypt_OpenSecretKey = function(eng: Integer; const src: PAnsiChar;
    nsrc: Integer; const passwd: PAnsiChar; key: PIPRIV_KEY): Integer; stdcall;
  TCrypt_OpenSecretKeyFromFile = function(eng: Integer; const path: PAnsiChar;
    const passwd: PAnsiChar; key: PIPRIV_KEY): Integer; stdcall;
  TCrypt_OpenSecretKeyFromStore = function(eng: longint; keyserial: longword;
    key: PIPRIV_KEY): Integer; stdcall;

  //         = function(Crypt_OpenPublicKey),    = function(Crypt_OpenPublicKeyFromFile)
  //       = function(Crypt_OpenPublicKeyFromStore).
  // eng: ,  
  // src: ,     
  // nsrc: ,  , -1 -    = function(  -)
  // path: ,      
  // keyserial: ,    
  // key: ,  
  // cakey: ,   0,      
  // : 0 -    

  TCrypt_OpenPublicKey = function(eng: longint; const src: PAnsiChar;
    nsrc: longint; keyserial: longword; key, cakey: PIPRIV_KEY)
    : Integer; stdcall;
  TCrypt_OpenPublicKeyFromFile = function(eng: longint; const path: PAnsiChar;
    keyserial: longword; key, cakey: PIPRIV_KEY): Integer; stdcall;
  TCrypt_OpenPublicKeyFromStore = function(eng: longint; keyserial: longword;
    key: PIPRIV_KEY): Integer; stdcall;

  //     = function(   ).
  // dst: ,     
  // ndst: ,    
  // path: ,      
  // passwd: ,      
  // key: ,  
  // :      

  TCrypt_ExportSecretKey = function(dst: PAnsiChar; ndst: Integer;
    const passwd: PAnsiChar; key: PIPRIV_KEY): Integer; stdcall;
  TCrypt_ExportSecretKeyToFile = function(const path: PAnsiChar;
    const passwd: PAnsiChar; key: PIPRIV_KEY): Integer; stdcall;

  //   .
  // dst: ,     
  // ndst: ,    
  // path: ,      
  // key: ,  
  // cakey: ,   0,       
  // :      

  TCrypt_ExportPublicKey = function(dst: PAnsiChar; ndst: Integer;
    key: PIPRIV_KEY; cakey: PIPRIV_KEY): Integer; stdcall;
  TCrypt_ExportPublicKeyToFile = function(const path: PAnsiChar;
    key: PIPRIV_KEY; cakey: PIPRIV_KEY): Integer; stdcall;

  //         = function(  ).
  // ,        eToken.
  // eng: ,  
  // src: ,     
  // nsrc: ,  , -1 -    = function(  -)
  // path: ,      
  // passwd: ,      
  // : 0 -    

  TCrypt_ImportSecretKey = function(eng: Integer; const src: PAnsiChar;
    nsrc: Integer; const passwd: PAnsiChar): Integer; stdcall;
  TCrypt_ImportSecretKeyFromFile = function(eng: Integer; const path: PAnsiChar;
    const passwd: PAnsiChar): Integer; stdcall;

  //         = function(  ).
  // ,        eToken.
  // eng: ,  
  // src: ,     
  // nsrc: ,  , -1 -    = function(  -)
  // path: ,      
  // keyserial: ,    
  // cakey: ,   0,      
  // : 0 -    

  TCrypt_ImportPublicKey = function(eng: Integer; const src: PAnsiChar;
    nsrc: Integer; keyserial: longword; cakey: PIPRIV_KEY): Integer; stdcall;
  TCrypt_ImportPublicKeyFromFile = function(eng: Integer; const path: PAnsiChar;
    keyserial: longword; cakey: PIPRIV_KEY): Integer; stdcall;

  //   .
  // src: ,    
  // nsrc:  , -1 -    = function(  -)
  // dst: ,      
  // ndst: ,    
  // key: ,  
  // :      

  TCrypt_Sign = function(const src: PAnsiChar; nsrc: Integer; dst: PAnsiChar;
    ndst: Integer; key: PIPRIV_KEY): Integer; stdcall;

  //   .
  // src: ,    
  // nsrc:  , -1 -    = function(  -)
  // pdst: ,   0,  ,        = function( )
  // pndst: ,   0,  ,        = function( )
  // key: ,  
  // : 0 -    

  TCrypt_Verify = function(const src: PAnsiChar; nsrc: Integer;
    const pdst: PPAnsiChar; pndst: PInteger; key: PIPRIV_KEY): Integer; stdcall;

  //   .       .
  // src: ,    
  // nsrc:  , -1 -    = function(  -)
  // dst: ,     
  // ndst: ,    
  // :      

  TCrypt_Encrypt = function(const src: PAnsiChar; nsrc: Integer; dst: PAnsiChar;
    ndst: Integer; key: PIPRIV_KEY): Integer; stdcall;

  //   .
  // src: ,    
  // nsrc:   , -1 -    = function(  -)
  // dst: ,    
  // ndst: ,    
  // :     
  TCrypt_Decrypt = function(const src: PAnsiChar; nsrc: Integer; dst: PAnsiChar;
    ndst: Integer; key: PIPRIV_KEY): Integer; stdcall;

  //  .
  // key: ,    
  // : 0 -    

  TCrypt_CloseKey = function(key: PIPRIV_KEY): Integer; stdcall;

  //  .
  //          = function(  ).
  // : 0 -    

  TCrypt_Done = function: Integer; stdcall;

var
  Crypt_Initialize: TCrypt_Initialize;
  Crypt_Ctrl_Null: TCrypt_Ctrl_Null;
  Crypt_Ctrl_String: TCrypt_Ctrl_String;
  Crypt_Ctrl_Int: TCrypt_Ctrl_Int;
  Crypt_Ctrl_Ptr: TCrypt_Ctrl_Ptr;
  Crypt_GenKeyCard: TCrypt_GenKeyCard;
  Crypt_GenKeyCardToFile: TCrypt_GenKeyCardToFile;
  Crypt_ReadKeyCardFromFile: TCrypt_ReadKeyCardFromFile;
  Crypt_GenKey: TCrypt_GenKey;
  Crypt_GenKeyFromFile: TCrypt_GenKeyFromFile;
  Crypt_GenKey2: TCrypt_GenKey2;
  Crypt_OpenSecretKey: TCrypt_OpenSecretKey;
  Crypt_OpenSecretKeyFromFile: TCrypt_OpenSecretKeyFromFile;
  Crypt_OpenSecretKeyFromStore: TCrypt_OpenSecretKeyFromStore;
  Crypt_OpenPublicKey: TCrypt_OpenPublicKey;
  Crypt_OpenPublicKeyFromFile: TCrypt_OpenPublicKeyFromFile;
  Crypt_OpenPublicKeyFromStore: TCrypt_OpenPublicKeyFromStore;
  Crypt_ExportSecretKey: TCrypt_ExportSecretKey;
  Crypt_ExportSecretKeyToFile: TCrypt_ExportSecretKeyToFile;
  Crypt_ExportPublicKey: TCrypt_ExportPublicKey;
  Crypt_ExportPublicKeyToFile: TCrypt_ExportPublicKeyToFile;
  Crypt_ImportSecretKey: TCrypt_ImportSecretKey;
  Crypt_ImportSecretKeyFromFile: TCrypt_ImportSecretKeyFromFile;
  Crypt_ImportPublicKey: TCrypt_ImportPublicKey;
  Crypt_ImportPublicKeyFromFile: TCrypt_ImportPublicKeyFromFile;
  Crypt_Sign: TCrypt_Sign;
  Crypt_Verify: TCrypt_Verify;
  Crypt_Encrypt: TCrypt_Encrypt;
  Crypt_Decrypt: TCrypt_Decrypt;
  Crypt_CloseKey: TCrypt_CloseKey;
  Crypt_Done: TCrypt_Done;

procedure LoadLib(var LibHandle: THandle; const LibDirectory: string = '');
procedure FreeLib(var LibHandle: THandle);

implementation

uses Winapi.Windows, System.SysUtils;

resourcestring
  sInvalidLibraryVersion = '   libipriv.dll';
  sLibraryNotFound = ' libipriv.dll  ';

const
  DLLName = 'libipriv.dll';

function GetModuleFileNameStr: string;
var
  Buffer: array [0 .. MAX_PATH] of Char;
begin
  FillChar(Buffer, MAX_PATH, #0);
  GetModuleFileName(hInstance, Buffer, MAX_PATH);
  Result := Buffer;
end;


function GetModuleDirectory: string;
begin
  Result := IncludeTrailingPathDelimiter(ExtractFileDir(GetModuleFileNameStr));
end;


procedure LoadLib(var LibHandle: THandle; const LibDirectory: string);

  function GetModuleSymbol(SymbolName: string): pointer;
  begin
    Result := GetProcAddress(LibHandle, PChar(SymbolName));
    if Result = nil then
      raise Exception.Create(sInvalidLibraryVersion);
  end;

var
  LLibDir: string;
begin
  if Length(LibDirectory) = 0 then
    LLibDir := GetModuleDirectory
  else
    LLibDir := LibDirectory;


  LibHandle := LoadLibrary(PChar(IncludeTrailingPathDelimiter(LLibDir) +
    DLLName));
  if LibHandle = 0 then
    raise Exception.Create(sLibraryNotFound)
  else
  begin
    try
      @Crypt_Initialize := GetModuleSymbol('Crypt_Initialize');
      @Crypt_Ctrl_Null := GetModuleSymbol('Crypt_Ctrl_Null');
      @Crypt_Ctrl_String := GetModuleSymbol('Crypt_Ctrl_String');
      @Crypt_Ctrl_Int := GetModuleSymbol('Crypt_Ctrl_Int');
      @Crypt_Ctrl_Ptr := GetModuleSymbol('Crypt_Ctrl_Ptr');
      @Crypt_GenKeyCard := GetModuleSymbol('Crypt_GenKeyCard');
      @Crypt_GenKeyCardToFile := GetModuleSymbol('Crypt_GenKeyCardToFile');
      @Crypt_ReadKeyCardFromFile :=
        GetModuleSymbol('Crypt_ReadKeyCardFromFile');
      @Crypt_GenKey := GetModuleSymbol('Crypt_GenKey');
      @Crypt_GenKeyFromFile := GetModuleSymbol('Crypt_GenKeyFromFile');
      @Crypt_GenKey2 := GetModuleSymbol('Crypt_GenKey2');
      @Crypt_OpenSecretKey := GetModuleSymbol('Crypt_OpenSecretKey');
      @Crypt_OpenSecretKeyFromFile :=
        GetModuleSymbol('Crypt_OpenSecretKeyFromFile');
      @Crypt_OpenSecretKeyFromStore :=
        GetModuleSymbol('Crypt_OpenSecretKeyFromStore');
      @Crypt_OpenPublicKey := GetModuleSymbol('Crypt_OpenPublicKey');
      @Crypt_OpenPublicKeyFromFile :=
        GetModuleSymbol('Crypt_OpenPublicKeyFromFile');
      @Crypt_OpenPublicKeyFromStore :=
        GetModuleSymbol('Crypt_OpenPublicKeyFromStore');
      @Crypt_ExportSecretKey := GetModuleSymbol('Crypt_ExportSecretKey');
      @Crypt_ExportSecretKeyToFile :=
        GetModuleSymbol('Crypt_ExportSecretKeyToFile');
      @Crypt_ExportPublicKey := GetModuleSymbol('Crypt_ExportPublicKey');
      @Crypt_ExportPublicKeyToFile :=
        GetModuleSymbol('Crypt_ExportPublicKeyToFile');
      @Crypt_ImportSecretKey := GetModuleSymbol('Crypt_ImportSecretKey');
      @Crypt_ImportSecretKeyFromFile :=
        GetModuleSymbol('Crypt_ImportSecretKeyFromFile');
      @Crypt_ImportPublicKey := GetModuleSymbol('Crypt_ImportPublicKey');
      @Crypt_ImportPublicKeyFromFile :=
        GetModuleSymbol('Crypt_ImportPublicKeyFromFile');
      @Crypt_Sign := GetModuleSymbol('Crypt_Sign');
      @Crypt_Verify := GetModuleSymbol('Crypt_Verify');
      @Crypt_Encrypt := GetModuleSymbol('Crypt_Encrypt');
      @Crypt_Decrypt := GetModuleSymbol('Crypt_Decrypt');
      @Crypt_CloseKey := GetModuleSymbol('Crypt_CloseKey');
      @Crypt_Done := GetModuleSymbol('Crypt_Done');
    except
      FreeLib(LibHandle);
      raise;
    end;
  end;
end;

procedure FreeLib(var LibHandle: THandle);
begin
  if LibHandle = 0 then
    Exit;

  FreeLibrary(LibHandle);
  LibHandle := 0;
end;

end.
